<?php

include "ObjCache.inc";

class	Planets
{
	var	$name;
	var	$coordx;
	var	$coordy;
	var	$tag;
	var	$govtype;
	var	$prodtype;
	var	$assigned_to;

	function	Planets($n, $x, $y, $g, $p)
	{
		$this->name		= $n;
		$this->coordx		= $x;
		$this->coordy		= $y;
		$this->govtype		= $g;
		$this->prodtype		= $p;
		$this->tag		= NULL;
		$this->assigned_to	= NULL;
		$_SESSION['cache']->newObject(&$this);
	}
}


class	Players
{
	var	$name;

	function	Players($name)
	{
		$this->name = $name;
		$_SESSION['cache']->newObject(&$this);
	}
}


session_name("octest");
session_start();

if	(!isset($_SESSION["cache"]))
{
	$_SESSION["cache"] = &new ObjCache("", "testoc2", "tseeker", "");
	$_SESSION["cache"]->addReference('planets', 'assigned_to', 'players');
	echo "init<br/>";
}
$cache = &$_SESSION['cache'];

if	(isset($_GET['creapl']))
{
	$pn = $_GET['player'];
	if	($pn != "")
	{
		$q = $cache->query("SELECT id FROM players WHERE name = '$pn'");
		if	($r = pg_fetch_array($q))
			$p = &$cache->getObject('players', $r[0]);
		else
		{
			$p = &new Players($pn);
			$cache->commitObject(&$p);
		}
	}
	else
		$p = null;

	$pl = &new Planets($_GET['creapl'], 0, 0, 0, 0);
	$pl->assigned_to = &$p;
	$cache->commitObject(&$pl);
}

$q = $cache->query("SELECT id FROM planets");
print pg_num_rows($q) . " planet(s)<br/>";
while	($r = pg_fetch_array($q))
{
	$pl = &$cache->getObject('planets', $r[0]);
	if	(is_null($pl))
		echo "Planet not found\n";
	else
	{
		echo "Planet " . $pl->name;
		$p = &$pl->assigned_to;
		if	(!is_null($p))
			echo " belonging to " . $p->name;
	}
	echo "<br>";
}

?>
<form method='get'>
 <input type='text' name='creapl' value='' />
 <input type='text' name='player' value='' />
 <input type='submit' value='Create planet' />
</form>
