<?php

include "ObjCache.inc";


class	Users
{
	var	$name;

	function	Users($name)
	{
		$this->name = $name;
		$_SESSION['cache']->newObject(&$this);
	}
}


class	Groups
{
	var	$name;

	function	Groups($name)
	{
		$this->name = $name;
		$_SESSION['cache']->newObject(&$this);
	}
}


session_name("octest");
session_start();

if	(!isset($_SESSION["cache"]))
{
	$_SESSION["cache"] = &new ObjCache("", "testoc3", "tseeker", "");

	$r = new RefTable("lk_users_groups");
	$r->addTarget("users", "userid", "users");
	$r->addTarget("groups", "groupid", "groups");
	$_SESSION["cache"]->addRefTable($r);

	echo "init<br/>";
}
$cache = &$_SESSION['cache'];


if	($_GET['ngroup'] != "")
{
	$g = &new Groups($_GET['ngroup']);
	$cache->commitObject(&$g);
}
elseif	($_GET['nuser'] != "")
{
	$u = &new Users($_GET['nuser']);
	$cache->commitObject(&$u);
}
elseif	($_GET['auser'] != '')
{
	$u = &$cache->getObject('users', $_GET['auser']);
	$g = &$cache->getObject('groups', $_GET['augroup']);
	$u->groups[count($u->groups)] = &$g;
	$cache->commitObject(&$u);
}


$q = $cache->query("SELECT id FROM users");
echo "USERS : ";
while	($r = pg_fetch_array($q))
{
	$user = &$cache->getObject('users', $r[0]);
	echo $user->name . " ";
}
echo "<br/>";

$q = $cache->query("SELECT id FROM groups");
echo "GROUPS : ";
while	($r = pg_fetch_array($q))
{
	$g = &$cache->getObject('groups', $r[0]);
	echo $g->name . " ";
}
echo "<br/>";

if	($_GET['ugroups'] != "")
{
	echo "<br/>";
	$q = $cache->query("SELECT id FROM users WHERE name = '" . $_GET['ugroups'] . "'");
	$r = pg_fetch_array($q);
	if	($r)
	{
		$u = &$cache->getObject('users', $r[0]);
		if	(!is_array($u->groups))
			echo "<b>Error : \$u->groups not set</b><br/>";
		else
		{
			echo "User <b>" . $_GET['ugroups'] . "</b> belongs to the following group(s) : ";
			for	($i=0;$i<count($u->groups);$i++)
				echo "<b>" . $u->groups[$i]->name . "</b> ";
			echo "<br/>";
		}
	}
	else
		echo "<b>Error : user '" . $_GET['ugroups'] . "' not found</b><br/>";
}
elseif	($_GET['gusers'] != "")
{
	echo "<br/>";
	$q = $cache->query("SELECT id FROM groups WHERE name = '" . $_GET['gusers'] . "'");
	$r = pg_fetch_array($q);
	if	($r)
	{
		$g = &$cache->getObject('groups', $r[0]);
		if	(!is_array($g->users))
			echo "<b>Error : \$g->users not set</b><br/>";
		else
		{
			echo "Group <b>" . $_GET['gusers'] . "</b> contains the following user(s) : ";
			for	($i=0;$i<count($g->users);$i++)
				echo "<b>" . $g->users[$i]->name . "</b> ";
			echo "<br/>";
		}
	}
	else
		echo "<b>Error : user '" . $_GET['ugroups'] . "' not found</b><br/>";
}

?>
<br/>
<form method='get'>
 Show groups for user <input type='text' name='ugroups' value='' /><br/>
 Show users for group <input type='text' name='gusers' value='' /><br/>
 Add user <input type='text' name='auser' value='' /> in
 group <input type='text' name='augroup' value='' /><br/>
 Create group <input type='text' name='ngroup' value='' /><br/>
 Create user <input type='text' name='nuser' value='' /><br/>
 <input type='submit' value='go' />
</form>
<br/>
<a href='reset.php'>RESET</a>
