<?php


class	RefTable
{
	var	$name;
	var	$refs;
	var	$flushed;

	function	RefTable($name)
	{
		$this->name = $name;
		$this->refs = array();
		$this->flushed = false;
	}

	function	addTarget($table, $fieldName, $arrayField = "")
	{
		$this->refs[$table] = array("fn" => $fieldName, "af" => $arrayField);
	}

	function	genQuery($t1, $v, $t2)
	{
		$q = "SELECT " . $this->refs[$t2]["fn"] . " FROM " . $this->name;
		$q .= " WHERE " . $this->refs[$t1]["fn"] . " = $v";
		$q .= " GROUP BY " . $this->refs[$t2]["fn"];
		return	$q;
	}

	function	genDelete($t1, $v)
	{
		$q = "DELETE FROM " . $this->name;
		$q .= " WHERE " . $this->refs[$t1]["fn"] . " = $v";
		return	$q;
	}

	function	genInsert($t1, $v1, $v2)
	{
		$ak = array_keys($this->refs);
		$t2 = ($ak[0] == $t1) ? $ak[1] : $ak[0];

		$f1 = $this->refs[$t1]["fn"];
		$f2 = $this->refs[$t2]["fn"];

		$q = "INSERT INTO " . $this->name . " ($f1, $f2) ";
		$q .= "VALUES ($v1, $v2)";
		return	$q;
	}

	function	__wakeup()
	{
		$this->flushed = false;
	}
}


?>
