<?php

/** ObjCache
 * This class implements the object cache.
 *
 * FIXME : no error management, no documentation ...
 */
class	ObjCache
{
	var	$dbHost;
	var	$dbName;
	var	$dbUser;
	var	$dbPass;
	var	$dbTable;
	var	$objs;

	function	ObjCache($h, $db, $u, $p, $t)
	{
		$this->dbHost	= $h;
		$this->dbName	= $db;
		$this->dbUser	= $u;
		$this->dbPass	= $p;
		$this->dbTable	= $t;
		$this->objs	= array();

		$this->db = pg_connect("host='$h' dbname='$db' user='$u' password='$p'");
		pg_query($this->db, "BEGIN TRANSACTION");
	}

	function	cacheKey(&$obj)
	{
		return get_class($obj) . ":" . $obj->__objCacheKey();
	}

	function	destroy()
	{
		$oks = array_keys($this->objs);
		foreach	($oks as $oid)
		{
			$q = "UPDATE " . $this->dbTable . " SET obj = '";
			$q .= preg_replace("/'/", "''", serialize($this->objs[$oid]));
			$q .= "', objkey = '" . preg_replace("/'/", "''", $this->cacheKey($this->objs[$oid]));
			$q .= "' WHERE id = $oid";
			pg_query($this->db, $q);
		}
		pg_query($this->db, "COMMIT");
		pg_close($this->db);
	}

	function	newObject(&$obj)
	{
		$r = pg_query($this->db, "SELECT nextval('obj_id_seq'::text)");
		$row = pg_fetch_array($r);
		$oid = $row[0];
		$obj->__objCacheId = $oid;
		$q = "INSERT INTO " . $this->dbTable . "(id, obj, objkey) VALUES ($oid, '";
		$q .= preg_replace("/'/", "''", serialize($obj)) . "', '";
		$q .= preg_replace("/'/", "''", $this->cacheKey($obj)) . "')";
		pg_query($this->db, $q);
		$this->objs[$oid] = &$obj;
	}

	function	&getObject($id)
	{
		$q = "SELECT obj FROM " . $this->dbTable . " WHERE id = $id FOR UPDATE";
		$r = pg_query($this->db, $q);
		$row = pg_fetch_array($r);
		return	($this->objs[$id] = unserialize($row[0]));
	}

	function	&getKey($key)
	{
		$q  = "SELECT obj,id FROM " . $this->dbTable . " WHERE objkey = '";
		$q .= preg_replace("/'/", "''", $key) . "' FOR UPDATE";
		$r = pg_query($this->db, $q);
		$row = pg_fetch_array($r);
		if	(!pg_num_rows($r))
			return	null;
		return	($this->objs[$row[1]] = unserialize($row[0]));
	}

	function	__sleep()
	{
		$this->destroy();
		return	array('dbHost', 'dbName', 'dbUser', 'dbPass', 'dbTable');
	}

	function	__wakeup()
	{
		$this->db = pg_connect(
			"host='" . $this->dbHost . "' "
			. "dbname='" . $this->dbName . "' "
			. "user='" . $this->dbUser . "' "
			. "password='" . $this->dbPass . "'"
		);
		pg_query($this->db, "BEGIN TRANSACTION");
		$this->objs = array();
	}
}

?>
